pipeline {
    agent any

    environment {
        AWS_ACCESS_KEY_ID = credentials('jenkins_aws_access_key_id')
        AWS_SECRET_ACCESS_KEY = credentials('jenkins_aws_secret_access_key')       
        TF_VAR_cluster_name = "my-eks-cluster"
        TF_VAR_region = "us-east-2"
    }

    stages {

        stage('build application') {
            steps {
               script {
                   echo "building the application..."
               }
            }
        }
        stage('build image from Dockerfile') {
            steps {
                script {
                    echo "building the docker image..."
                }
            }
        }
         stage('push artifact to repo') {
            steps {
                script {
                    echo "building the docker image..."
                }
            }
        }       

        stage('provision EKS cluster') {
            steps {
                script {
                    dir('terraform') {
                        echo "creating EKS cluster"
                        sh "terraform init"
                        //sh "terraform apply --auto-approve"
                        sh "terraform destroy --auto-approve"
                        
                        // set kubeconfig access
                        sh "aws eks update-kubeconfig --name ${TF_VAR_cluster_name} --region ${TF_VAR_region}"
                    }
                }
            }
        }

        stage('deploy app on EKS') {
            steps {
                script {
                    echo "Accessing the EKS cluster"

                     sh "kubectl apply -f deployment.yaml"
                   //sh "kubectl delete -f deployment.yaml"
                   
                }
            }
        }
    }
}
